package spinnerloaderwrapper;

import main.java.com.fenjuly.mylibrary.SpinnerLoader;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.BA.Events;
import android.view.MotionEvent;

import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.View.OnTouchListener;
import android.view.ViewParent;

import android.graphics.BitmapShader;
import android.graphics.Shader;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.RectShape;

@Author("Johan Schoeman")
@Version(1.00f)
@ShortName("SpinnerLoader")
public class spinnerLoaderWrapper extends ViewWrapper<SpinnerLoader> implements DesignerCustomView  {


	private BA ba;
	private String eventName;
        private SpinnerLoader cv;
 
	
	/*
	 * Initialize the HTML-TextView 
	 */   


	
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new SpinnerLoader(ba.context, null);
                this.setObject(cv);
//                addListener();
 	}


//    @Hide
//    public void addListener(){
//        cv.setCallback(new RingButton.Callback() {
//            @Override
//            public void top_clicked() {

//              if (ba.subExists(eventName + "_top_clicked")) {
//                ba.raiseEvent2(ba, false, eventName + "_top_clicked", true, new Object[0]);
//              }
//            }

//            @Override
//            public void bottom_clicked() {

//              if (ba.subExists(eventName + "_bottom_clicked")) {
//                ba.raiseEvent2(ba, false, eventName + "_bottom_clicked", true, new Object[0]);
//              }
//            }

//        });
//    }


	
	//programmatically add view
        @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}

	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}

    public void setPointcolor(int color) {
        cv.setPointcolor(color);
        cv.invalidate();
    }

//    public void isDynamic(boolean dynamic) {
//        cv.isDynamic(dynamic);
//        cv.invalidate();
//    }

//    public void setPointsCount(int pointscount) {
//         cv.setPointsCount(pointscount);
//         cv.invalidate();
//    }

//    public void setStep(int step) {
//         cv.setStep(step);
//         cv.invalidate();
//    }

//    public void setBigStep(int step) {
//         cv.setBigStep(step);
//         cv.invalidate();
//    }

//    public void setDefaultColor(int color) {
//         cv.setDefaultColor(color);
//         cv.invalidate();
//    }    

//    public void setDefaultRadius(float radius) {
//         cv.setDefaultRadius(radius);
//         cv.invalidate();
//    }    

    public void setDefaultCircleRadius(float radius) {
         cv.setDefaultCircleRadius(radius);
         cv.invalidate();
    }    

    public void setDefaultMoveRadius(float radius) {
         cv.setDefaultMoveRadius(radius);
         cv.invalidate();
    }    

//    public void setSplitAngle(int splitangle) {
//         cv.setSplitAngle(splitangle);
//         cv.invalidate();
//    }    

//    public void setAdditionLenght(int length) {
//         cv.setAdditionLenght(length);
//         cv.invalidate();
//    }    

//    public void setFlatAngle(int angle) {
//         cv.setFlatAngle(angle);
//         cv.invalidate();
//    }    



}
